PHP Manual
Prev | Chapter 2. Installation | Next

# Complete list of configure options

> Note: These are only used at compile time. If you want to alter PHP's runtime configuration, please see the chapter on Configuration.

The following is a complete list of options supported by PHP 4 `configure` scripts (as of 4.1.0), used when compiling in Unix-like environments. Some are available in PHP 3, some in PHP 4, and some in both. This is not noted yet.

- Database

- Graphics

- Miscellaneous

- PHP Behaviour

- Server

- XML

## Configure Options in PHP 4

> Note: These options are only used in PHP 4 as of PHP 4.1.0. Some are available in older versions of PHP 4, some even in PHP 3, some only in PHP 4.1.0. If you want to compile an older version, some options will probably not be available.

### Database options

`--with-db`

  Include old xDBM support (deprecated).

`--enable-dba=shared`

  Build DBA as a shared module.

`--with-gdbm[=DIR]`

  Include GDBM support.

`--with-ndbm[=DIR]`

  Include NDBM support.

`--with-db2[=DIR]`

  Include Berkeley DB2 support.

`--with-db3[=DIR]`

  Include Berkeley DB3 support.

`--with-dbm[=DIR]`

  Include DBM support.

`--with-cdb[=DIR]`

  Include CDB support.

`--enable-dbase`

  Enable the bundled dbase library.

`--with-dbplus`

  Include dbplus support.

`--enable-dbx`

  Enable dbx.

`--with-fbsql[=DIR]`

  Include FrontBase support. DIR is the FrontBase base directory.

`--enable-filepro`

  Enable the bundled read-only filePro support.

`--with-fribidi[=DIR]`

  Include fribidi support (requires FriBidi >=0.1.12). DIR is the fribidi installation directory - default /usr/local/.

`--with-informix[=DIR]`

  Include Informix support. DIR is the Informix base install directory, defaults to nothing.

`--with-ingres[=DIR]`

  Include Ingres II support. DIR is the Ingres base directory (default /II/ingres).

`--with-interbase[=DIR]`

  Include InterBase support. DIR is the InterBase base install directory, defaults to /usr/interbase.

`--with-msql[=DIR]`

  Include mSQL support. DIR is the mSQL base install directory, defaults to /usr/local/Hughes.

`--with-mysql[=DIR]`

  Include MySQL support. DIR is the MySQL base directory. If unspecified, the bundled MySQL library will be used.

`--with-oci8[=DIR]`

  Include Oracle-oci8 support. Default DIR is ORACLE_HOME.

`--with-adabas[=DIR]`

  Include Adabas D support. DIR is the Adabas base install directory, defaults to /usr/local.

`--with-sapdb[=DIR]`

  Include SAP DB support. DIR is SAP DB base install directory, defaults to /usr/local.

`--with-solid[=DIR]`

  Include Solid support. DIR is the Solid base install directory, defaults to /usr/local/solid.

`--with-ibm-db2[=DIR]`

  Include IBM DB2 support. DIR is the DB2 base install directory, defaults to /home/db2inst1/sqllib.

`--with-empress[=DIR]`

  Include Empress support. DIR is the Empress base install directory, defaults to $EMPRESSPATH. From PHP4, this option only supports Empress Version 8.60 and above.

`--with-empress-bcs[=DIR]`

  Include Empress Local Access support. DIR is the Empress base install directory, defaults to $EMPRESSPATH. From PHP4, this option only supports Empress Version 8.60 and above.

`--with-velocis[=DIR]`

  Include Velocis support. DIR is the Velocis base install directory, defaults to /usr/local/velocis.

`--with-custom-odbc[=DIR]`

  Include a user defined ODBC support. The DIR is ODBC install base directory, which defaults to /usr/local. Make sure to define CUSTOM_ODBC_LIBS and have some odbc.h in your include dirs. E.g., you should define following for Sybase SQL Anywhere 5.5.00 on QNX, prior to run configure script: CPPFLAGS="-DODBC_QNX -DSQLANY_BUG" LDFLAGS=-lunix CUSTOM_ODBC_LIBS="-ldblib -lodbc".

`--with-iodbc[=DIR]`

  Include iODBC support. DIR is the iODBC base install directory, defaults to /usr/local.

`--with-esoob[=DIR]`

  Include Easysoft OOB support. DIR is the OOB base install directory, defaults to /usr/local/easysoft/oob/client.

`--with-unixODBC[=DIR]`

  Include unixODBC support. DIR is the unixODBC base install directory, defaults to /usr/local.

`--with-openlink[=DIR]`

  Include OpenLink ODBC support. DIR is the OpenLink base install directory, defaults to /usr/local. This is the same as iODBC.

`--with-dbmaker[=DIR]`

  Include DBMaker support. DIR is the DBMaker base install directory, defaults to where the latest version of DBMaker is installed (such as /home/dbmaker/3.6).

`--with-oracle[=DIR]`

  Include Oracle-oci7 support. Default DIR is ORACLE_HOME.

`--with-ovrimos[=DIR]`

  Include Ovrimos SQL Server support. DIR is the Ovrimos' libsqlcli install directory.

`--with-pgsql[=DIR]`

  Include PostgreSQL support. DIR is the PostgreSQL base install directory, defaults to /usr/local/pgsql. Set DIR to shared to build as a dl, or shared,DIR to build as a dl and still specify DIR.

`--with-sybase[=DIR]`

  Include Sybase-DB support. DIR is the Sybase home directory, defaults to /home/sybase.

`--with-sybase-ct[=DIR]`

  Include Sybase-CT support. DIR is the Sybase home directory. Defaults to /home/sybase.

`--disable-unified-odbc`

  Disable unified ODBC support. Only applicable if iODBC, Adabas, Solid, Velocis or a custom ODBC interface is enabled. PHP 3 only!

### Graphics options

`--with-gd[=DIR]`

  Include GD support (DIR is GD's install dir). Set DIR to shared to build as a dl, or shared,DIR to build as a dl and still specify DIR.

`--enable-gd-native-ttf`

  GD: Enable TrueType string function in gd.

`--with-jpeg-dir=DIR`

  GD: Set the path to libjpeg install prefix.

`--with-png-dir=DIR`

  GD: Set the path to libpng install prefix.

`--with-xpm-dir=DIR`

  GD: Set the path to libXpm install prefix.

`--with-freetype-dir=DIR`

  GD: Set the path to freetype2 install prefix.

`--with-ttf[=DIR]`

  GD: Include FreeType 1.x support.

`--with-t1lib[=DIR]`

  GD: Include T1lib support.

`--with-cpdflib[=DIR]`

  Include cpdflib support (requires cpdflib >= 2). DIR is the cpdfllib install directory, defaults to /usr.

`--with-jpeg-dir[=DIR]`

  jpeg dir for cpdflib 2.x.

`--with-tiff-dir[=DIR]`

  tiff dir for cpdflib 2.x.

`--with-pdflib[=DIR]`

  Include PDFlib support. DIR is the pdflib base install directory, defaults to /usr/local. Set DIR to shared to build as dl, or shared,DIR to build as dl and still specify DIR.

`--with-jpeg-dir[=DIR]`

  PDFLIB: define libjpeg install directory.

`--with-png-dir[=DIR]`

  PDFLIB: define libpng install directory.

`--with-tiff-dir[=DIR]`

  PDFLIB: define libtiff install directory.

`--with-swf[=DIR]`

  Include swf support.

`--without-gd`

  Disable GD support. PHP 3 only!

`--with-imagick`

  Include ImageMagick support. DIR is the install directory, and if left out, PHP will try to find it on its own. [experimental]. PHP 3 only!

`--with-ming[=DIR]`

  Include ming support.

### Misc options

`--enable-force-cgi-redirect`

  Enable the security check for internal server redirects. You should use this if you are running the CGI version with Apache.

`--enable-discard-path`

  If this is enabled, the PHP CGI binary can safely be placed outside of the web tree and people will not be able to circumvent .htaccess security.

`--with-fastcgi=SRCDIR`

  Build PHP as FastCGI application.

`--enable-debug`

  Compile with debugging symbols.

`--with-layout=TYPE`

  Sets how installed files will be laid out. Type is one of PHP (default) or GNU.

`--with-pear=DIR`

  Install PEAR in DIR (default PREFIX/lib/php).

`--without-pear`

  Do not install PEAR.

`--with-openssl[=DIR]`

  Include OpenSSL support (requires OpenSSL >= 0.9.5).

`--enable-sigchild`

  Enable PHP's own SIGCHLD handler.

`--disable-rpath`

  Disable passing additional runtime library search paths.

`--enable-libgcc`

  Enable explicitly linking against libgcc.

`--enable-dmalloc`

  Enable dmalloc.

`--enable-php-streams`

  Include experimental php streams. Do not use unless you are testing the code!

`--with-zlib-dir=<DIR>`

  Define the location of zlib install directory.

`--with-zlib[=DIR]`

  Include zlib support (requires zlib >= 1.0.9). DIR is the zlib install directory.

`--with-aspell[=DIR]`

  Include ASPELL support.

`--enable-bcmath`

  Enable bc style precision math functions.

`--with-bz2[=DIR]`

  Include BZip2 support.

`--enable-calendar`

  Enable support for calendar conversion.

`--with-ccvs[=DIR]`

  Include CCVS support.

`--with-crack[=DIR]`

  Include crack support.

`--enable-ctype`

  Enable ctype support.

`--with-curl[=DIR]`

  Include CURL support.

`--with-cybercash[=DIR]`

  Include CyberCash support. DIR is the CyberCash MCK install directory.

`--with-cybermut[=DIR]`

  Include CyberMut (french Credit Mutuel telepaiement).

`--with-cyrus`

  Include cyrus imap support.

`--enable-exif`

  Enable exif support.

`--with-fdftk[=DIR]`

  Include fdftk support.

`--enable-ftp`

  Enable FTP support.

`--with-gettext[=DIR]`

  Include GNU gettext support. DIR is the gettext install directory, defaults to /usr/local.

`--with-gmp`

  Include gmp support.

`--with-hyperwave`

  Include Hyperwave support.

`--with-icap[=DIR]`

  Include ICAP support.

`--with-iconv[=DIR]`

  Include iconv support.

`--with-imap[=DIR]`

  Include IMAP support. DIR is the c-client install prefix.

`--with-kerberos[=DIR]`

  IMAP: Include Kerberos support. DIR is the Kerberos install dir.

`--with-imap-ssl[=DIR]`

  IMAP: Include SSL support. DIR is the OpenSSL install dir.

`--with-ircg-config`

  Path to the ircg-config script.

`--with-ircg`

  Include ircg support.

`--with-java[=DIR]`

  Include Java support. DIR is the base install directory for the JDK. This extension can only be built as a shared dl.

`--with-ldap[=DIR]`

  Include LDAP support. DIR is the LDAP base install directory.

`--enable-mailparse`

  Enable mailparse support.

`--enable-mbstring`

  Enable multibyte string support.

`--enable-mbstr-enc-trans`

  Enable japanese encoding translation.

`--with-mcal[=DIR]`

  Include MCAL support.

`--with-mcrypt[=DIR]`

  Include mcrypt support. DIR is the mcrypt install directory.

`--with-mhash[=DIR]`

  Include mhash support. DIR is the mhash install directory.

`--with-mnogosearch[=DIR]`

  Include mnoGoSearch support. DIR is the mnoGoSearch base install directory, defaults to /usr/local/mnogosearch.

`--with-muscat[=DIR]`

  Include muscat support.

`--with-ncurses`

  Include ncurses support.

`--enable-pcntl`

  Enable experimental pcntl support (CGI ONLY!)

`--without-pcre-regex`

  Do not include Perl Compatible Regular Expressions support. Use --with-pcre-regex=DIR to specify DIR where PCRE's include and library files are located, if not using bundled library.

`--with-pfpro[=DIR]`

  Include Verisign Payflow Pro support.

`--disable-posix`

  Disable POSIX-like functions.

`--with-pspell[=DIR]`

  Include PSPELL support.

`--with-qtdom`

  Include QtDOM support (requires Qt >= 2.2.0).

`--with-libedit[=DIR]`

  Include libedit readline replacement.

`--with-readline[=DIR]`

  Include readline support. DIR is the readline install directory.

`--with-recode[=DIR]`

  Include recode support. DIR is the recode install directory.

`--with-satellite[=DIR]`

  Enable CORBA support via Satellite (EXPERIMENTIAL) DIR is the base directory for ORBit.

`--with-mm[=DIR]`

  Include mm support for session storage.

`--enable-trans-sid`

  Enable transparent session id propagation.

`--disable-session`

  Disable session support.

`--enable-shmop`

  Enable shmop support.

`--with-snmp[=DIR]`

  Include SNMP support. DIR is the SNMP base install directory, defaults to searching through a number of common locations for the snmp install. Set DIR to shared to build as a dl, or shared,DIR to build as a dl and still specify DIR.

`--enable-ucd-snmp-hack`

  Enable UCD SNMP hack.

`--enable-sockets`

  Enable sockets support.

`--with-regex=TYPE`

  regex library type: system, apache, php.

`--with-system-regex`

  Use system regex library (deprecated).

`--enable-sysvsem`

  Enable System V semaphore support.

`--enable-sysvshm`

  Enable the System V shared memory support.

`--with-vpopmail[=DIR]`

  Include vpopmail support.

`--with-tsrm-pthreads`

  Use POSIX threads (default).

`--enable-shared[=PKGS]`

  Build shared libraries [default=yes].

`--enable-static[=PKGS]`

  Build static libraries [default=yes].

`--enable-fast-install[=PKGS]`

  Optimize for fast installation [default=yes].

`--with-gnu-ld`

  Assume the C compiler uses GNU ld [default=no].

`--disable-libtool-lock`

  Avoid locking (might break parallel builds).

`--with-pic`

  Try to use only PIC/non-PIC objects [default=use both].

`--with-yaz[=DIR]`

  Include YAZ support (ANSI/NISO Z39.50). DIR is the YAZ bin install directory.

`--enable-memory-limit`

  Compile with memory limit support.

`--disable-url-fopen-wrapper`

  Disable the URL-aware fopen wrapper that allows accessing files via http or ftp.

`--enable-versioning`

  Export only required symbols. See INSTALL for more information.

`--disable-bcmath`

  Compile without bc style precision math functions. PHP 3 only!

`--with-imsp[=DIR]`

  Include IMSp support (DIR is IMSP's include dir and libimsp.a dir). PHP 3 only!

`--with-ftp`

  Include FTP support. PHP 3 only!

`--with-mck[=DIR]`

  Include Cybercash MCK support. DIR is the cybercash mck build directory, defaults to /usr/src/mck-3.2.0.3-linux for help look in extra/cyberlib. PHP 3 only!

`--disable-overload`

  Disable user-space object overloading support. PHP 3 only!

`--enable-yp`

  Include YP support. PHP 3 only!

`--with-zip`

  Include ZIP support (requires zziplib >= 0.10.6). PHP 3 only!

`--with-mod-dav=DIR`

  Include DAV support through Apache's mod_dav, DIR is mod_dav's installation directory (Apache module version only!) PHP 3 only!

`--enable-debugger`

  Compile with remote debugging functions. PHP 3 only!

`--enable-versioning`

  Take advantage of versioning and scoping provided by Solaris 2.x and Linux. PHP 3 only!

### PHP options

`--enable-maintainer-mode`

  Enable make rules and dependencies not useful (and sometimes confusing) to the casual installer.

`--with-config-file-path=PATH`

  Sets the path in which to look for php.ini, defaults to PREFIX/lib.

`--enable-safe-mode`

  Enable safe mode by default.

`--with-exec-dir[=DIR]`

  Only allow executables in DIR when in safe mode defaults to /usr/local/php/bin.

`--enable-magic-quotes`

  Enable magic quotes by default.

`--disable-short-tags`

  Disable the short-form <? start tag by default.

### Server options

`--with-aolserver=DIR`

  Specify path to the installed AOLserver.

`--with-apxs[=FILE]`

  Build shared Apache module. FILE is the optional pathname to the Apache apxs tool; defaults to apxs.

`--with-apache[=DIR]`

  Build Apache module. DIR is the top-level Apache build directory, defaults to /usr/local/apache.

`--with-mod_charset`

  Enable transfer tables for mod_charset (Rus Apache).

`--with-apxs2[=FILE]`

  Build shared Apache 2.0 module. FILE is the optional pathname to the Apache apxs tool; defaults to apxs.

`--with-fhttpd[=DIR]`

  Build fhttpd module. DIR is the fhttpd sources directory, defaults to /usr/local/src/fhttpd.

`--with-isapi=DIR`

  Build PHP as an ISAPI module for use with Zeus.

`--with-nsapi=DIR`

  Specify path to the installed Netscape Server.

`--with-phttpd=DIR`

  No information yet.

`--with-pi3web=DIR`

  Build PHP as a module for use with Pi3Web.

`--with-roxen=DIR`

  Build PHP as a Pike module. DIR is the base Roxen directory, normally /usr/local/roxen/server.

`--enable-roxen-zts`

  Build the Roxen module using Zend Thread Safety.

`--with-servlet[=DIR]`

  Include servlet support. DIR is the base install directory for the JSDK. This SAPI prereqs the java extension must be built as a shared dl.

`--with-thttpd=SRCDIR`

  Build PHP as thttpd module.

`--with-tux=MODULEDIR`

  Build PHP as a TUX module (Linux only).

### XML options

`--with-dom[=DIR]`

  Include DOM support (requires libxml >= 2.4.2). DIR is the libxml install directory, defaults to /usr.

`--disable-xml`

  Disable XML support using bundled expat lib.

`--with-expat-dir=DIR`

  XML: external libexpat install dir.

`--with-xmlrpc[=DIR]`

  Include XMLRPC-EPI support.

`--enable-wddx`

  Enable WDDX support.

Prev | Home | Next
Problems? | Up | Configuration